package org.xdoclet.plugin.spring.qtags;

public class SpringBeanTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.spring.qtags.SpringBeanTag {
    public static final String NAME = "spring.bean";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"name",
		"autowire",
		"dependency-check",
		"description",
		"destroy-method",
		"parent",
		"init-method",
		"lazy-init",
		"singleton",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public SpringBeanTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public SpringBeanTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = false;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getName_() {
		boolean required = false;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAutowire() {
		boolean required = false;
        String result = getNamedParameter("autowire");
        if(required && result == null) {
            bomb("autowire=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("byName")|| result.equals("byType")|| result.equals("constructor")|| result.equals("auto-detect")|| result.equals("no")) ) {
	                // todo we should say what file and line number too
	                bomb("autowire=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDependencyCheck() {
		boolean required = false;
        String result = getNamedParameter("dependency-check");
        if(required && result == null) {
            bomb("dependency-check=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("simple")|| result.equals("objects")|| result.equals("all")|| result.equals("none")) ) {
	                // todo we should say what file and line number too
	                bomb("dependency-check=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDestroyMethod() {
		boolean required = false;
        String result = getNamedParameter("destroy-method");
        if(required && result == null) {
            bomb("destroy-method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getParent() {
		boolean required = false;
        String result = getNamedParameter("parent");
        if(required && result == null) {
            bomb("parent=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getInitMethod() {
		boolean required = false;
        String result = getNamedParameter("init-method");
        if(required && result == null) {
            bomb("init-method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getLazyInit() {
		boolean required = false;
        String result = getNamedParameter("lazy-init");
        if(required && result == null) {
            bomb("lazy-init=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getSingleton() {
		boolean required = false;
        String result = getNamedParameter("singleton");
        if(required && result == null) {
            bomb("singleton=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getName_();
        getAutowire();
        getDependencyCheck();
        getDescription();
        getDestroyMethod();
        getParent();
        getInitMethod();
        getLazyInit();
        getSingleton();
    }

    public void validateModel() {
        // check uniqueness
    }
}